<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Notification;
use App\Models\UserToken;
use App\User;
use Carbon\Carbon;
use Edujugon\PushNotification\PushNotification;
use Illuminate\Http\Request;

class UsersController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $rows = User::whereType('user')->orderByDesc('id')->get();
        return view('admin.users.index', compact('rows'));
    }

    public function change_vip($user_id, $status, Request $request)
    {
        User::where('id', $user_id)->update([
            'vip' => $status
        ]);
        $user = User::find($user_id);

        if ($status == 'true') {
            $user->end_subscription = Carbon::parse($user->end_subscription)->addYear();
            $user->update();
        }





        $notification = new Notification();
        $notification['user_id'] = $user->id;
        $notification['title->ar'] ='عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح';
        $notification['title->en'] = 'Our dear customer, the annual subscription package has been subscribed successfully';
        $notification['body->en'] = 'Our dear customer, the annual subscription package has been subscribed successfully';
        $notification['body->ar'] = 'عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح';
        $notification['type'] = 'admin';
        $notification->save();


        $push = new PushNotification('fcm');

        $all_tokens = UserToken::where('status', 'connected')->where('user_id',$user->id)->get();
        foreach ($all_tokens as $token) {

            if ($token->device_type == 'ios') {
                $msg = [
                    'data' => [
                        'title_ar' => 'عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح',
                        'title_en' =>'Our dear customer, the annual subscription package has been subscribed successfully',
                        'body_ar' => 'عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح',
                        'body_en' => 'Our dear customer, the annual subscription package has been subscribed successfully',
                        'type' => 'admin',
                        'sound' => 'default',
                        'click_action' => 'FCM_PLUGIN_ACTIVITY',
                    ],
                    'notification' => [
                        'title_ar' => 'عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح',
                        'title_en' =>'Our dear customer, the annual subscription package has been subscribed successfully',
                        'body_ar' => 'عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح',
                        'body_en' => 'Our dear customer, the annual subscription package has been subscribed successfully',
                        'type' => 'admin',
                        'sound' => 'default',
                        'click_action' => 'FCM_PLUGIN_ACTIVITY',
                    ],
                    'priority' => 'high',
                ];
                $push->setMessage($msg)
                    ->setDevicesToken($token->token)
//                    ->setDevicesToken(['ebCHXhMNaeY:APA91bHum93eW_tS1PtongfnwshnV3DnAb-5p9eyeoYo0KO4JeU40_uiaSB8yMbglBNEg__4gvN3EPrjSOQrmJF_psHjWnL4ESOoSpLqlIYI1sl-4_hQcFDoYYQXc81qh6UondKDg25E','fRc28JagsI0:APA91bHC7tjKQ6CXPNkvusWqYYbjPqo3gaMl8O3Mzg84WTK4VTXK6abK1iuRbCDHT99pGZIxF7jnm_plbHAEaYZG3fKz4c9k6XnrUTMSUn1qUkMzXtLTTnTnAss4yNz2GALrKyPqZLNe'])
                    ->send();


            } else {
                $msg = [
                    'data' => [
                        'title_ar' => 'عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح',
                        'title_en' =>'Our dear customer, the annual subscription package has been subscribed successfully',
                        'body_ar' => 'عميلنا العزيز تم الإشتراك في باقه الإشتراك السنوي بنجاح',
                        'body_en' => 'Our dear customer, the annual subscription package has been subscribed successfully',
                        'type' => 'admin',
                        'sound' => 'default',
                        'click_action' => 'FCM_PLUGIN_ACTIVITY',
                    ],
                    'priority' => 'high',
                ];
                $push->setMessage($msg)
                    ->setDevicesToken($token->token)
//                    ->setDevicesToken(['ebCHXhMNaeY:APA91bHum93eW_tS1PtongfnwshnV3DnAb-5p9eyeoYo0KO4JeU40_uiaSB8yMbglBNEg__4gvN3EPrjSOQrmJF_psHjWnL4ESOoSpLqlIYI1sl-4_hQcFDoYYQXc81qh6UondKDg25E','fRc28JagsI0:APA91bHC7tjKQ6CXPNkvusWqYYbjPqo3gaMl8O3Mzg84WTK4VTXK6abK1iuRbCDHT99pGZIxF7jnm_plbHAEaYZG3fKz4c9k6XnrUTMSUn1qUkMzXtLTTnTnAss4yNz2GALrKyPqZLNe'])
                    ->send();

            }


        }
















        return redirect()->back()->with('message', 'تم تغيير حالة الاشتراك بنجاح');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.users.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required',
            'email' => 'required|email|unique:users',
            'mobile' => 'required|unique:users',
            'password' => 'required|min:6',
            'status' => 'required|in:active,not_active'
        ]);
        $user = new User();
        $user['name'] = $request['name'];
        $user['email'] = $request['email'];
        $user['mobile'] = $request['mobile'];
        $user['status'] = $request['status'];
        $user['password'] = bcrypt($request['password']);
        $user['type'] = 'user';
        $user->save();
        return redirect()->route('users.index')->with('message', 'تم الانشاء بنجاح');


    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $row = User::find($id);
        return view('admin.users.edit', compact('row'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'name' => 'required',
            'email' => 'required|email|unique:users,email,' . $id,
            'mobile' => 'required|unique:users,mobile,' . $id,
            'password' => 'nullable|min:6',
            'status' => 'required|in:active,not_active'
        ]);
        $user = User::find($id);
        $user['name'] = $request['name'];
        $user['email'] = $request['email'];
        $user['status'] = $request['status'];
        if ($request['password']) $user['password'] = bcrypt($request['password']);

        $user['type'] = 'user';
        $user['mobile'] = $request['mobile'];
        $user->update();
        return redirect()->route('users.index')->with('message', 'تم التعديل بنجاح');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        User::destroy($id);
        return redirect()->back()->with('message', 'تم الحذف بنجاح');
    }
}
